import type { GetDocumentTypeNamesGen } from '@contentlayer/core'
import type * as SourceFiles from '@contentlayer/source-files'
import { defineDocumentType } from '@contentlayer/source-files'

// TODO remove this once fixed https://github.com/microsoft/TypeScript/issues/37151#issuecomment-756232934
interface GenHelper {
  names: GetDocumentTypeNamesGen
}

export const addComputedFields = <DefName extends GenHelper>({
  documentTypes,
  documentTypeName,
  computedFields,
}: {
  documentTypes: SourceFiles.DocumentType[]
  documentTypeName: DefName['names']
  computedFields: SourceFiles.ComputedFields<DefName['names']>
}): void => {
  const documentType = documentTypes.find((_) => _.def().name === documentTypeName)

  if (!documentType) {
    throw new Error(`Document type "${documentTypeName}" not found`)
  }

  const previousDef = documentType.def()
  documentType.def = defineDocumentType(() => ({ ...previousDef, computedFields })).def
}
